Bug 94401 - Add support for making a web site become paginated using overflow: paged-x | paged-y
Summary: Add support for making a web site become paginated using overflow: paged-x | ...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: CSS (show other bugs)
Version: 528+ (Nightly build)
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Beth Dakin
URL:
Keywords: InRadar, WebExposed
Depends on:
Blocks: 94748
  Show dependency treegraph
 
Reported: 2012-08-17 17:32 PDT by Beth Dakin
Modified: 2012-08-23 14:00 PDT (History)
14 users (show)

See Also:


Attachments
Patch for feedback (56.67 KB, patch)
2012-08-17 18:01 PDT, Beth Dakin
no flags Details | Formatted Diff | Diff
Patch (827.85 KB, patch)
2012-08-20 17:29 PDT, Beth Dakin
no flags Details | Formatted Diff | Diff
Patch for style bot (827.84 KB, patch)
2012-08-20 17:39 PDT, Beth Dakin
no flags Details | Formatted Diff | Diff
Attempt to get other ports building (828.92 KB, patch)
2012-08-20 18:17 PDT, Beth Dakin
gns: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-08 (1.47 MB, application/zip)
2012-08-20 19:38 PDT, WebKit Review Bot
no flags Details
Will it build, v2 (829.38 KB, patch)
2012-08-21 11:28 PDT, Beth Dakin
gns: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-06 (1.27 MB, application/zip)
2012-08-21 13:47 PDT, WebKit Review Bot
no flags Details
Will it build, v3 (830.65 KB, patch)
2012-08-21 13:49 PDT, Beth Dakin
webkit.review.bot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-07 (1.27 MB, application/zip)
2012-08-21 15:02 PDT, WebKit Review Bot
no flags Details
Will it build, v4 (832.24 KB, patch)
2012-08-21 15:50 PDT, Beth Dakin
no flags Details | Formatted Diff | Diff
Without printfs this time (832.21 KB, patch)
2012-08-21 16:02 PDT, Beth Dakin
buildbot: commit-queue-
Details | Formatted Diff | Diff
Will it build, v5 (832.33 KB, patch)
2012-08-21 17:02 PDT, Beth Dakin
hyatt: review+
Details | Formatted Diff | Diff
Archive of layout-test-results from gce-cr-linux-07 (1.38 MB, application/zip)
2012-08-21 22:30 PDT, WebKit Review Bot
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Beth Dakin 2012-08-17 17:32:21 PDT
Hyatt wants something like overflow-style implemented in WebKit (read about overflow-style here: http://dev.w3.org/csswg/css3-gcpm/#paged-presentations ), but as new values on overflow-y instead of a new property named overflow-style.

<rdar://problem/11831783>

I have a patch that gets a lot of this done, and I will post it soon to get feedback.
Comment 1 Beth Dakin 2012-08-17 18:01:55 PDT
Created attachment 159247 [details]
Patch for feedback
Comment 2 Dave Hyatt 2012-08-20 11:19:52 PDT
Comment on attachment 159247 [details]
Patch for feedback 

View in context: https://bugs.webkit.org/attachment.cgi?id=159247&action=review

Everything looks good. As also mentioned, when dealing with overflow areas, the content width is what you want to use to set up the column width.

> Source/WebCore/css/CSSParser.cpp:1776
> +            overflowXValue = cssValuePool().createIdentifierValue(CSSValueHidden);

As discussed, for now, let's make this default to auto for paged-x and hidden for paged-y.

> Source/WebCore/page/FrameView.cpp:159
> +    // is horizontal, then the direction of the horizontality dictates the choice. If the WritingMode

It is fantastic that you managed to work "horizontality" into a comment. What a great word! :)
Comment 3 Beth Dakin 2012-08-20 17:29:12 PDT
Created attachment 159572 [details]
Patch
Comment 4 WebKit Review Bot 2012-08-20 17:33:30 PDT
Attachment 159572 [details] did not pass style-queue:

Failed to run "['Tools/Scripts/check-webkit-style', '--diff-files', u'LayoutTests/ChangeLog', u'LayoutTests/fast..." exit_code: 1
Source/WebCore/rendering/Pagination.h:26:  #ifndef header guard has wrong style, please use: Pagination_h  [build/header_guard] [5]
Total errors found: 1 in 38 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 5 Beth Dakin 2012-08-20 17:39:35 PDT
Created attachment 159576 [details]
Patch for style bot
Comment 6 Beth Dakin 2012-08-20 18:17:19 PDT
Created attachment 159582 [details]
Attempt to get other ports building
Comment 7 Gustavo Noronha (kov) 2012-08-20 18:50:43 PDT
Comment on attachment 159582 [details]
Attempt to get other ports building

Attachment 159582 [details] did not pass gtk-ews (gtk):
Output: http://queues.webkit.org/results/13538883
Comment 8 WebKit Review Bot 2012-08-20 19:38:13 PDT
Comment on attachment 159582 [details]
Attempt to get other ports building

Attachment 159582 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/13549192

New failing tests:
fast/overflow/paged-y-div.html
fast/overflow/paged-y-on-root.html
fast/overflow/paged-x-on-root.html
fast/overflow/paged-x-div.html
Comment 9 WebKit Review Bot 2012-08-20 19:38:18 PDT
Created attachment 159594 [details]
Archive of layout-test-results from gce-cr-linux-08

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-08  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid
Comment 10 Build Bot 2012-08-21 08:00:05 PDT
Comment on attachment 159582 [details]
Attempt to get other ports building

Attachment 159582 [details] did not pass win-ews (win):
Output: http://queues.webkit.org/results/13547493
Comment 11 Beth Dakin 2012-08-21 11:28:57 PDT
Created attachment 159727 [details]
Will it build, v2
Comment 12 Gustavo Noronha (kov) 2012-08-21 12:40:57 PDT
Comment on attachment 159727 [details]
Will it build, v2

Attachment 159727 [details] did not pass gtk-ews (gtk):
Output: http://queues.webkit.org/results/13550496
Comment 13 WebKit Review Bot 2012-08-21 13:47:16 PDT
Comment on attachment 159727 [details]
Will it build, v2

Attachment 159727 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/13550518

New failing tests:
fast/overflow/paged-y-div.html
fast/overflow/paged-y-on-root.html
fast/overflow/paged-x-on-root.html
fast/overflow/paged-x-div.html
Comment 14 WebKit Review Bot 2012-08-21 13:47:22 PDT
Created attachment 159761 [details]
Archive of layout-test-results from gce-cr-linux-06

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-06  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid
Comment 15 Beth Dakin 2012-08-21 13:49:03 PDT
Created attachment 159762 [details]
Will it build, v3

Okay, I am optimistic about this one for GTK.
Comment 16 WebKit Review Bot 2012-08-21 15:02:02 PDT
Comment on attachment 159762 [details]
Will it build, v3

Attachment 159762 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/13564012

New failing tests:
fast/overflow/paged-y-div.html
fast/overflow/paged-y-on-root.html
fast/overflow/paged-x-on-root.html
fast/overflow/paged-x-div.html
Comment 17 WebKit Review Bot 2012-08-21 15:02:07 PDT
Created attachment 159774 [details]
Archive of layout-test-results from gce-cr-linux-07

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-07  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid
Comment 18 Build Bot 2012-08-21 15:17:02 PDT
Comment on attachment 159762 [details]
Will it build, v3

Attachment 159762 [details] did not pass win-ews (win):
Output: http://queues.webkit.org/results/13561016
Comment 19 Beth Dakin 2012-08-21 15:50:59 PDT
Created attachment 159783 [details]
Will it build, v4
Comment 20 WebKit Review Bot 2012-08-21 15:56:01 PDT
Attachment 159783 [details] did not pass style-queue:

Failed to run "['Tools/Scripts/check-webkit-style', '--diff-files', u'ChangeLog', u'LayoutTests/ChangeLog', u'La..." exit_code: 1
Source/WebCore/rendering/RenderView.cpp:229:  Missing space after ,  [whitespace/comma] [3]
Total errors found: 1 in 43 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 21 Beth Dakin 2012-08-21 16:02:02 PDT
Created attachment 159787 [details]
Without printfs this time
Comment 22 Build Bot 2012-08-21 16:52:26 PDT
Comment on attachment 159787 [details]
Without printfs this time

Attachment 159787 [details] did not pass win-ews (win):
Output: http://queues.webkit.org/results/13557084
Comment 23 Beth Dakin 2012-08-21 17:02:03 PDT
Created attachment 159808 [details]
Will it build, v5
Comment 24 Dean Jackson 2012-08-21 17:32:51 PDT
It's time to go HAM on these builders.
Comment 25 WebKit Review Bot 2012-08-21 22:30:06 PDT
Comment on attachment 159808 [details]
Will it build, v5

Attachment 159808 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/13566133

New failing tests:
fast/overflow/paged-y-div.html
fast/overflow/paged-y-on-root.html
fast/overflow/paged-x-on-root.html
fast/overflow/paged-x-div.html
Comment 26 WebKit Review Bot 2012-08-21 22:30:10 PDT
Created attachment 159861 [details]
Archive of layout-test-results from gce-cr-linux-07

The attached test failures were seen while running run-webkit-tests on the chromium-ews.
Bot: gce-cr-linux-07  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid
Comment 27 Beth Dakin 2012-08-22 10:44:03 PDT
(In reply to comment #26)
> Created an attachment (id=159861) [details]
> Archive of layout-test-results from gce-cr-linux-07
> 
> The attached test failures were seen while running run-webkit-tests on the chromium-ews.
> Bot: gce-cr-linux-07  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid

I think Chromium-specific test results are in order here. It just seems like small pixel differences that come down to platform differences.
Comment 28 Beth Dakin 2012-08-22 11:32:45 PDT
(In reply to comment #27)
> (In reply to comment #26)
> > Created an attachment (id=159861) [details] [details]
> > Archive of layout-test-results from gce-cr-linux-07
> > 
> > The attached test failures were seen while running run-webkit-tests on the chromium-ews.
> > Bot: gce-cr-linux-07  Port: <class 'webkitpy.common.config.ports.ChromiumXVFBPort'>  Platform: Linux-2.6.39-gcg-201203291735-x86_64-with-Ubuntu-10.04-lucid
> 
> I think Chromium-specific test results are in order here. It just seems like small pixel differences that come down to platform differences.

I wonder if these results should go in the chromium directory or the chromium-linux directory?
Comment 29 Dave Hyatt 2012-08-22 12:56:35 PDT
Comment on attachment 159808 [details]
Will it build, v5

r=me
Comment 30 Beth Dakin 2012-08-22 13:21:26 PDT
Thanks, Dave! Committed change with http://trac.webkit.org/changeset/126343

I didn't check in the new chromium expectations because I wasn't sure whether to put them in chromium or chromium-linux.